/*
 *    Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

/**
 * ConnectionType.java
 * <p/>
 * File generated from the ATNAQuestionnaire::ConnectionType uml Enumeration
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.atna.questionnaire.model;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import net.ihe.gazelle.hql.FilterLabel;

/**
 * Description of the enumeration ConnectionType.
 *
 * /!\ WARNING /!\
 *
 * This enumeration is used to map connection types of atna-questionnaires with TM webservice connection types.
 * IDEs won't be able to find usage of this enum in the code, so be carefull if a modification has to be done.
 */

@XmlType(name = "ConnectionType")
@XmlEnum
@XmlRootElement(name = "ConnectionType")
public enum ConnectionType {
    @XmlEnumValue("HL7v2")
    HL7V2("HL7v2", "HL7v2"),
    @XmlEnumValue("Syslog")
    SYSLOG("Syslog", "Syslog"),
    @XmlEnumValue("WebService")
    WEBSERVICE("WebService", "WebService"),
    @XmlEnumValue("DICOM")
    DICOM("DICOM", "DICOM"),
    @XmlEnumValue("Raw")
    OTHER("Raw", "Other"),
    @XmlEnumValue("HTTP")
    HTTP("HTTP", "HTTP");

    private final String friendlyName;
    private final String valueFromTM;

    ConnectionType(String v, String vtm) {
        friendlyName = v;
        valueFromTM = vtm;
    }

    public String value() {
        return friendlyName;
    }

    @FilterLabel
    public String getFriendlyName() {
        return friendlyName;
    }

    public static ConnectionType fromValueInTM(String v) {
        for (ConnectionType c : ConnectionType.values()) {
            if (c.valueFromTM.equalsIgnoreCase(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

}